#version 150

varying vec2 vTextureCoord;
varying vec4 vPosition;

uniform sampler2D uDiffuseSampler;
uniform float uAlphaMultiplier;

uniform vec2 uBlurDirection;
uniform float uBlurAmount;

void main(void)
{
		vec4 sum = vec4(0,0,0,1);
        float magnitude = uBlurAmount;

         sum += texture2D(uDiffuseSampler, vec2(vTextureCoord.x - (5.0 * magnitude * uBlurDirection.x), vTextureCoord.y - (5.0 * magnitude * uBlurDirection.y))) * 0.01;
         sum += texture2D(uDiffuseSampler, vec2(vTextureCoord.x - (4.0 * magnitude * uBlurDirection.x), vTextureCoord.y - (4.0 * magnitude * uBlurDirection.y))) * 0.05;
         sum += texture2D(uDiffuseSampler, vec2(vTextureCoord.x - (3.0 * magnitude * uBlurDirection.x), vTextureCoord.y - (3.0 * magnitude * uBlurDirection.y))) * 0.09;
         sum += texture2D(uDiffuseSampler, vec2(vTextureCoord.x - (2.0 * magnitude * uBlurDirection.x), vTextureCoord.y - (2.0 * magnitude * uBlurDirection.y))) * 0.12;
         sum += texture2D(uDiffuseSampler, vec2(vTextureCoord.x - (1.0 * magnitude * uBlurDirection.x), vTextureCoord.y - (1.0 * magnitude * uBlurDirection.y))) * 0.15;
         sum += texture2D(uDiffuseSampler, vec2(vTextureCoord.x, vTextureCoord.y)) * 0.16;
         sum += texture2D(uDiffuseSampler, vec2(vTextureCoord.x + (1.0 * magnitude * uBlurDirection.x), vTextureCoord.y + (1.0 * magnitude * uBlurDirection.y))) * 0.15;
         sum += texture2D(uDiffuseSampler, vec2(vTextureCoord.x + (2.0 * magnitude * uBlurDirection.x), vTextureCoord.y + (2.0 * magnitude * uBlurDirection.y))) * 0.12;
         sum += texture2D(uDiffuseSampler, vec2(vTextureCoord.x + (3.0 * magnitude * uBlurDirection.x), vTextureCoord.y + (3.0 * magnitude * uBlurDirection.y))) * 0.09;
         sum += texture2D(uDiffuseSampler, vec2(vTextureCoord.x + (4.0 * magnitude * uBlurDirection.x), vTextureCoord.y + (4.0 * magnitude * uBlurDirection.y))) * 0.05;
         sum += texture2D(uDiffuseSampler, vec2(vTextureCoord.x + (5.0 * magnitude * uBlurDirection.x), vTextureCoord.y + (5.0 * magnitude * uBlurDirection.y))) * 0.01;

        gl_FragColor = sum * vec4(1,1,1,uAlphaMultiplier);
}