#version 150

attribute vec3 aVertexPosition;
attribute vec3 aVertexNormal;

uniform mat4 uModelMatrix;
uniform mat4 uViewMatrix;
uniform mat4 uProjectionMatrix;
uniform mat3 uNormalMatrix;

varying vec3 vTransformedNormal;
varying vec4 vPosition;

uniform vec3 uWaveAmplitude;
uniform vec3 uWaveOffset;
uniform vec3 uWavelength;

void main(void)
{
    vPosition = vec4(aVertexPosition, 1.0);
	
    vPosition.xyz += //aVertexNormal * 
	vec3(
	cos((vPosition.x + uWaveOffset.x) * uWavelength.x),
	cos((vPosition.y + uWaveOffset.y) * uWavelength.y),
	cos((vPosition.z + uWaveOffset.z) * uWavelength.z)) 
	* uWaveAmplitude;
	
    vPosition = uModelMatrix * vPosition;

    gl_Position = uProjectionMatrix * uViewMatrix * vPosition;
    vTransformedNormal = uNormalMatrix * aVertexNormal;
}