#version 150

varying vec2 vTextureCoord;
varying vec4 vPosition;

uniform sampler2D uDiffuseSampler;
uniform float uAlphaMultiplier;

uniform float uContrast;
uniform float uSaturation;
uniform float uBrightness;

vec3 ContrastSaturationBrightness(vec3 color, float brt, float sat, float con)
{
	const float AvgLumR = 0.5;
	const float AvgLumG = 0.5;
	const float AvgLumB = 0.5;

	const vec3 LumCoeff = vec3(0.2125, 0.7154, 0.0721);

	vec3 AvgLumin = vec3(AvgLumR, AvgLumG, AvgLumB);
	vec3 brtColor = color * brt;
	vec3 intensity = vec3(dot(brtColor, LumCoeff));
	vec3 satColor = mix(intensity, brtColor, sat);
	vec3 conColor = mix(AvgLumin, satColor, con);
	return conColor;
}

void main(void)
{
    vec2 tC = vTextureCoord.st;
    vec4 baseSample = texture2D(uDiffuseSampler, tC);
         baseSample = vec4(ContrastSaturationBrightness(baseSample.rgb, uBrightness, uSaturation, uContrast), baseSample.a);
    gl_FragColor = baseSample * vec4(1,1,1,uAlphaMultiplier);
}