#version 150

varying vec2 vTextureCoord;
varying vec4 vPosition;

uniform sampler2D uDiffuseSampler;
uniform sampler2D uDisplaceSampler;
uniform float uAlphaMultiplier;
uniform float uDisplaceMagnitude;

uniform vec2 uTexCoordOffset;
uniform vec4 uDiffuseValue;

void main(void)
{
	vec2 displace = normalize(((texture2D (uDisplaceSampler, vTextureCoord + uTexCoordOffset * 0.25).xyz * 2.0) - 1.0).rg) * uDisplaceMagnitude;
	
    vec4 sampleA = texture2D(uDiffuseSampler, vTextureCoord- uTexCoordOffset + displace);
    vec4 sampleB = texture2D(uDiffuseSampler, (vTextureCoord + uTexCoordOffset * 0.5) * 2.0 + displace);
   
    gl_FragColor = vec4(vec3(pow((sampleA.r + sampleB.r), 2.0)), 1.0);
	gl_FragColor *= uDiffuseValue;
	gl_FragColor.a *= uAlphaMultiplier;
}