#version 150

varying vec2 vTextureCoord;
varying vec4 vPosition;

uniform sampler2D uDiffuseSampler;
uniform sampler2D uDepthSampler;

uniform vec3 uTint;

uniform float uProgress;
uniform float uNearPlane;
uniform float uFarPlane;

uniform float uHorizontalWaveTime;
uniform float uVerticalWaveTime;

void main(void)
{ 
	vec4 base = texture2D(uDiffuseSampler, vTextureCoord);
    vec4 depth = texture2D(uDepthSampler, vec2(vTextureCoord.s, vTextureCoord.t));
    float linearDepth = (2.0 * uNearPlane) / (uFarPlane + uNearPlane - depth.r * (uFarPlane - uNearPlane));

	// ADJUST DEPTH FOR EDGE DETAIL
	linearDepth += (sin(vTextureCoord.s * 32.0 + uHorizontalWaveTime) * sin(vTextureCoord.t * 2.0 + uVerticalWaveTime*1.0)) * 0.0025;
	linearDepth += (cos(vTextureCoord.t * 18.0 + uVerticalWaveTime) * cos(vTextureCoord.s * 4.0 + uHorizontalWaveTime*2.0)) * 0.0025;
	
	float currentValue = 1.0 - (uProgress);
	
    if(linearDepth > currentValue)
    {
       gl_FragColor = vec4(length(base.rgb) * uTint, 1.0);
    }
    else
    {
        gl_FragColor = base;
    }
	
}