#version 150

varying vec2 vTextureCoord;

uniform sampler2D uDiffuseSampler;
uniform float uAlphaMultiplier;

void main(void)
{
    vec4 textureColor = texture2D(uDiffuseSampler, vec2(vTextureCoord.s, vTextureCoord.t));
    float alpha = (textureColor.a*uAlphaMultiplier) < 1.0 ? 0.0 : 0.85;
    gl_FragColor = vec4(textureColor.rgb, alpha);
}