#version 150

attribute vec3 aVertexPosition;
attribute vec4 aModelMatrix_A;
attribute vec4 aModelMatrix_B;
attribute vec4 aModelMatrix_C;
attribute vec4 aModelMatrix_D;

uniform mat4 uViewMatrix;
uniform mat4 uProjectionMatrix;

varying vec4 vPosition;

void main(void)
{
    mat4 modelMatrix = mat4(aModelMatrix_A, aModelMatrix_B, aModelMatrix_C, aModelMatrix_D);
	vPosition = modelMatrix * vec4(aVertexPosition, 1.0);
    gl_Position = uProjectionMatrix * uViewMatrix * vPosition;
}