#version 150

varying vec2 vTextureCoord;
varying vec4 vPosition;

uniform sampler2D uBaseSampler;
uniform sampler2D uDiffuseSampler;
uniform float uAlphaMultiplier;

uniform vec2 uMagnitude;
uniform vec2 uOffset;
uniform vec2 uScreenSize;

void main(void)
{
    vec2 tC = vTextureCoord.st;
    vec2 displace = vec2(texture2D(uBaseSampler, tC+uOffset).rg);

    displace = vec2(2.0) * (displace-vec2(0.5));
    displace *= uMagnitude;
    displace /= uScreenSize;
    
    gl_FragColor = texture2D(uDiffuseSampler, tC + displace) * vec4(1,1,1,uAlphaMultiplier);
}