#version 150

varying vec2 vTextureCoord;

uniform sampler2D uDiffuseSampler;
uniform vec4 uDiffuseValue;
uniform sampler2D uDisplaceSampler;
uniform float uAlphaMultiplier;

uniform float uMagnitude;
uniform vec2 uScreenSize;

void main(void)
{
    vec2 tC = vTextureCoord.st;
	vec2 displace = (texture2D(uDisplaceSampler, tC).xy * 2.0) - 1.0;
    displace *= uMagnitude;
    displace /= uScreenSize;
	
	gl_FragColor = texture2D(uDiffuseSampler, tC + displace);
	gl_FragColor.rgb *= uDiffuseValue.rgb;
	gl_FragColor.a *= uAlphaMultiplier;
}