#version 150

varying vec3 vTransformedNormal;
varying vec4 vPosition;
varying vec2 vTextureCoord;
varying vec4 vTangent;
uniform vec4 uDiffuseValue;
uniform vec3 uSpecularValue;
uniform sampler2D uNormalSampler;
uniform sampler2D uSecondaryNormalSampler;
uniform vec3 uAmbientValue;
uniform float uSpecularIntensity;
uniform vec3 uPointLightingPositions[10];
uniform vec3 uPointLightingColors[10];
uniform float uPointLightingInvRadii[10];
uniform float uPointLightDistanceOffset[10];
uniform int uPointLightCount;
uniform vec3 uDirectionalLightingDirections[10];
uniform vec3 uDirectionalLightingColors[10];
uniform int uDirectionalLightCount;
uniform vec3 uSpotLightingPositions[10];
uniform vec3 uSpotLightingDirections[10];
uniform vec3 uSpotLightingColors[10];
uniform float uSpotLightingInvRadii[10];
uniform float uSpotLightingCutoffs[10];
uniform float uSpotLightingOuterCutoffs[10];
uniform int uSpotLightCount;
uniform vec3 uCameraPosition;
uniform vec4 uFogColor;
uniform float uFogDensity;

uniform vec2 uCoarseNormalMapOffset;
uniform vec2 uFineNormalMapOffset;

void main ()
{
  vec3 lightWeighting_2;
  vec3 specularHighlight_3;
  vec3 specularValue_4;
  float specularIntensity_5;
  vec3 eyeDirection_6;
  vec3 normal_7;
  vec3 tmpvar_8;
  tmpvar_8 = normalize(vTransformedNormal);
  eyeDirection_6 = normalize((uCameraPosition - vPosition.xyz));
  specularIntensity_5 = uSpecularIntensity;
  vec3 tmpvar_9;
  tmpvar_9 = normalize(vTangent.xyz);
  vec3 tmpvar_10;
  tmpvar_10 = ((tmpvar_8.yzx * tmpvar_9.zxy) - (tmpvar_8.zxy * tmpvar_9.yzx));
  mat3 tmpvar_11;
  tmpvar_11[0].x = tmpvar_9.x;
  tmpvar_11[0].y = tmpvar_10.x;
  tmpvar_11[0].z = tmpvar_8.x;
  tmpvar_11[1].x = tmpvar_9.y;
  tmpvar_11[1].y = tmpvar_10.y;
  tmpvar_11[1].z = tmpvar_8.y;
  tmpvar_11[2].x = tmpvar_9.z;
  tmpvar_11[2].y = tmpvar_10.z;
  tmpvar_11[2].z = tmpvar_8.z;
  
  normal_7 = normalize(normalize(((texture2D (uNormalSampler, vTextureCoord + uCoarseNormalMapOffset).xyz * 2.0) - 1.0) +
  ((texture2D (uSecondaryNormalSampler, vTextureCoord + uFineNormalMapOffset).xyz * 2.0) - 1.0)) * tmpvar_11);
  
  specularValue_4 = uSpecularValue;
  specularHighlight_3 = vec3(0.0, 0.0, 0.0);
  lightWeighting_2 = vec3(0.0, 0.0, 0.0);
  for (int i_1 = 0; i_1 < 10; i_1++) {
    if ((i_1 < uPointLightCount)) {
      vec3 tmpvar_12;
      tmpvar_12 = (uPointLightingPositions[i_1] - vPosition.xyz);
      float tmpvar_13;
      tmpvar_13 = clamp ((1.0 - (uPointLightingInvRadii[i_1] * 
        sqrt(dot (tmpvar_12, tmpvar_12)) - uPointLightDistanceOffset[i_1]
      )), 0.0, 1.0);
      vec3 tmpvar_14;
      tmpvar_14 = normalize(tmpvar_12);
      lightWeighting_2 = (lightWeighting_2 + ((uPointLightingColors[i_1] * 
        max (dot (normal_7, tmpvar_14), 0.0)
      ) * tmpvar_13));
      vec3 I_15;
      I_15 = -(tmpvar_14);
      specularHighlight_3 = (specularHighlight_3 + ((
        (specularValue_4 * uPointLightingColors[i_1])
       * 
        pow (max (dot ((I_15 - 
          (2.0 * (dot (normal_7, I_15) * normal_7))
        ), eyeDirection_6), 0.0), specularIntensity_5)
      ) * tmpvar_13));
    };
    if ((i_1 < uDirectionalLightCount)) {
      lightWeighting_2 = (lightWeighting_2 + (uDirectionalLightingColors[i_1] * max (
        dot (normal_7, uDirectionalLightingDirections[i_1])
      , 0.0)));
    };
    if ((i_1 < uSpotLightCount)) {
      vec3 tmpvar_16;
      tmpvar_16 = (uSpotLightingPositions[i_1] - vPosition.xyz);
      float tmpvar_17;
      tmpvar_17 = clamp ((1.0 - (uSpotLightingInvRadii[i_1] * 
        sqrt(dot (tmpvar_16, tmpvar_16))
      )), 0.0, 1.0);
      vec3 tmpvar_18;
      tmpvar_18 = normalize(tmpvar_16);
      float tmpvar_19;
      tmpvar_19 = max (dot (normal_7, tmpvar_18), 0.0);
      float tmpvar_20;
      tmpvar_20 = dot (-(tmpvar_18), normalize(uSpotLightingDirections[i_1]));
      if ((tmpvar_19 > 0.0)) {
        vec3 spotContribution_21;
        spotContribution_21 = vec3(0.0, 0.0, 0.0);
        float tmpvar_22;
        tmpvar_22 = cos(uSpotLightingCutoffs[i_1]);
        float tmpvar_23;
        tmpvar_23 = cos(uSpotLightingOuterCutoffs[i_1]);
        if ((tmpvar_20 > tmpvar_22)) {
          spotContribution_21 = ((uSpotLightingColors[i_1] * tmpvar_19) * tmpvar_17);
        } else {
          if ((tmpvar_20 > tmpvar_23)) {
            spotContribution_21 = (((uSpotLightingColors[i_1] * tmpvar_19) * (
              (tmpvar_20 - tmpvar_23)
             / 
              (tmpvar_22 - tmpvar_23)
            )) * tmpvar_17);
          };
        };
        lightWeighting_2 = (lightWeighting_2 + spotContribution_21);
      };
    };
  };
  //lightWeighting_2 = (lightWeighting_2 + uAmbientValue);
  vec4 tmpvar_24;
  tmpvar_24.xyz = (uDiffuseValue.xyz * lightWeighting_2);
  tmpvar_24.w = uDiffuseValue.w;
  gl_FragColor.w = tmpvar_24.w;
  gl_FragColor.xyz = ((tmpvar_24.xyz*0.25) + specularHighlight_3);
  float tmpvar_25;
  tmpvar_25 = (gl_FragCoord.z / gl_FragCoord.w);
  gl_FragColor = mix (uFogColor, gl_FragColor, clamp (exp2(
    ((((
      -(uFogDensity)
     * uFogDensity) * tmpvar_25) * tmpvar_25) * 1.442695)
  ), 0.0, 1.0));
}

