#version 150

attribute vec3 aVertexPosition;
attribute vec3 aVertexNormal;
attribute vec2 aTextureCoord;
attribute vec4 aTangent;

uniform mat4 uModelMatrix;
uniform mat4 uViewMatrix;
uniform mat4 uProjectionMatrix;
uniform mat3 uNormalMatrix;

varying vec3 vTransformedNormal;
varying vec4 vPosition;
varying vec2 vTextureCoord;
varying vec4 vTangent;

void main ()
{
  vec4 tmpvar_1;
  tmpvar_1.w = 1.0;
  tmpvar_1.xyz = aVertexPosition;
  
  vPosition = (uModelMatrix * tmpvar_1);
  gl_Position = ((uProjectionMatrix * uViewMatrix) * vPosition);
  
  vTransformedNormal = (uNormalMatrix * aVertexNormal);
  vTextureCoord = aTextureCoord;
  vTangent = aTangent;
}

