#version 150

varying vec2 vTextureCoord;
varying vec4 vPosition;

uniform vec4 uDiffuseValue;
uniform float uThreshold;
uniform float uAlphaMultiplier;
uniform vec2 uScreenSize;
uniform sampler2D uDiffuseSampler;

uniform int uMetaballCount;
uniform vec2 uMetaballPositions[10];
uniform float uMetaballRadii[10];

void main(void)
{
    vec2 tC = vTextureCoord.st;
	tC.x = fract(tC.x);
	vec4 texture = texture2D(uDiffuseSampler, vTextureCoord.st);
	
	gl_FragColor = vec4(0,0,0,uAlphaMultiplier);
	
	float accumulator = 0.0;
	
	for(int i = 0; i < 10; i ++)
	{
		if(i>= uMetaballCount)
			break;
			
		float radius = uMetaballRadii[i] / uScreenSize.x;
		vec2 position = uMetaballPositions[i] / uScreenSize;
			
		float value = radius / sqrt(pow(position.x - tC.x, 2.0) + pow(position.y - tC.y, 2.0));
			
		// Horizontal tiling
		value += radius / sqrt(pow((position.x + 1.0) - tC.x, 2.0) + pow(position.y - tC.y, 2.0));
		value += radius / sqrt(pow((position.x - 1.0) - tC.x, 2.0) + pow(position.y - tC.y, 2.0));
			
		accumulator += value*0.333333;
	}
		
	if(accumulator > uThreshold)
	{
		gl_FragColor = uDiffuseValue * texture * vec4(1,1,1,uAlphaMultiplier);
	}
	else
		discard;
}