#version 150

uniform float uSeed;
uniform float uScale;
uniform vec2 uOffset;
uniform float uAlpha;

varying vec2 vTextureCoord;
uniform sampler2D uDiffuseSampler;

float rand(vec2 co){
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}

void main(void)
{
    vec2 coord = vec2(gl_FragCoord.x/uScale, gl_FragCoord.y/uScale);
    
    coord.x = ceil(coord.x);
    coord.y = ceil(coord.y);

	float baseSample = 1.0 - rand(coord * uSeed);
    gl_FragColor = vec4(baseSample,baseSample,baseSample,texture2D(uDiffuseSampler, vTextureCoord + uOffset).r * uAlpha);
}