#version 150

varying vec2 vTextureCoord;
varying vec4 vPosition;

uniform sampler2D uDiffuseSampler;
uniform sampler2D uDepthSampler;

uniform vec3 uTint;

uniform float uProgress;
uniform float uNearPlane;
uniform float uFarPlane;

uniform float uHorizontalWaveTime;
uniform float uVerticalWaveTime;

uniform float uSeed;
uniform float uAlphaMultiplier;

float rand(vec2 co){
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}

void main(void)
{ 
	vec4 base = texture2D(uDiffuseSampler, vTextureCoord);
    vec4 depth = texture2D(uDepthSampler, vec2(vTextureCoord.s, vTextureCoord.t));
    float linearDepth = (2.0 * uNearPlane) / (uFarPlane + uNearPlane - depth.r * (uFarPlane - uNearPlane));

	// ADJUST DEPTH FOR EDGE DETAIL
	linearDepth += (sin(vTextureCoord.s * 32.0 + uHorizontalWaveTime) * sin(vTextureCoord.t * 2.0 + uVerticalWaveTime*1.0)) * 0.0025;
	linearDepth += (cos(vTextureCoord.t * 18.0 + uVerticalWaveTime) * cos(vTextureCoord.s * 4.0 + uHorizontalWaveTime*2.0)) * 0.0025;
	
	float currentValue = 1.0 - (uProgress);
	
    if(linearDepth > currentValue)
    {
	   vec2 coord = vec2(gl_FragCoord.x/1.0, gl_FragCoord.y/1.0);
    
		coord.x = ceil(coord.x);
		coord.y = ceil(coord.y);

		float baseSample = max(uAlphaMultiplier,rand(coord * uSeed));
		gl_FragColor = vec4(vec3(baseSample)*length(base.rgb),1.0);
    }
    else
    {
        gl_FragColor = base;
    }
	
}