#version 150

varying vec2 vTextureCoord;
varying vec4 vPosition;

uniform sampler2D uDiffuseSampler;
uniform vec2 uOffset;

void main(void)
{
	vec4 sampleA = texture2D(uDiffuseSampler, vTextureCoord);
	vec4 sampleB = texture2D(uDiffuseSampler, vTextureCoord + uOffset);
	
	float value = length(sampleA.rgb) / 3.0;
	
	if(value > 0.15)
		value = 1.0;
		else
		value = 0.0;
	
	vec3 color = sampleB.rgb;
	
    gl_FragColor = vec4(color, 1.0) * value;
}