#version 150

attribute vec3 aVertexPosition;
attribute vec3 aVertexNormal;

uniform mat4 uModelMatrix;
uniform mat4 uViewMatrix;
uniform mat4 uProjectionMatrix;

uniform float uOutlineScale;

varying vec3 vDir;

void main(void)
{
	vec3 direction = normalize(aVertexNormal);
	vDir = direction;
    gl_Position = uModelMatrix * vec4(aVertexPosition + (direction*uOutlineScale), 1.0);
    gl_Position = uProjectionMatrix * uViewMatrix * gl_Position;
}