#version 150

#define M_PI 3.1415926535897932384626433832795

attribute vec3 aVertexPosition;
attribute vec3 aVertexNormal;

uniform mat4 uModelMatrix;
uniform mat4 uViewMatrix;
uniform mat4 uProjectionMatrix;
uniform mat3 uNormalMatrix;

uniform vec2 uGerstDirection;
uniform float uGerstnerWavelength;
uniform float uGerstnerQ;
uniform float uGerstnerDisplaceMagnitude;
uniform float uGerstnerAccumulator;

uniform vec2 uSineOrigin;
uniform float uSineAccumulator;
uniform float uSineDisplaceWavelength;
uniform float uSineDisplaceMagnitude;

varying vec3 vTransformedNormal;
varying vec4 vPosition;

void main ()
{
  vec4 tmpvar_1;
  tmpvar_1.w = 1.0;
  tmpvar_1.xyz = aVertexPosition;
  vPosition = (uModelMatrix * tmpvar_1);
  gl_Position = ((uProjectionMatrix * uViewMatrix) * vPosition);
  
  vTransformedNormal = (uNormalMatrix * aVertexNormal);
}

