#version 150

varying vec4 vPosition;
varying vec3 vTransformedNormal;

uniform vec4 uDiffuseValue;
uniform vec3 uSpecularValue;
uniform float uSpecularIntensity;

uniform vec3 uAmbientValue;
uniform vec3 uPointLightingPositions[10];
uniform vec3 uPointLightingColors[10];
uniform float uPointLightingInvRadii[10];
uniform int uPointLightCount;
uniform vec3 uDirectionalLightingDirections[10];
uniform vec3 uDirectionalLightingColors[10];
uniform int uDirectionalLightCount;
uniform vec3 uSpotLightingPositions[10];
uniform vec3 uSpotLightingDirections[10];
uniform vec3 uSpotLightingColors[10];
uniform float uSpotLightingInvRadii[10];
uniform float uSpotLightingCutoffs[10];
uniform float uSpotLightingOuterCutoffs[10];
uniform int uSpotLightCount;
uniform vec4 uFogColor;
uniform float uFogDensity;
uniform float uFogHeightStart;
uniform float uFogHeightFalloff;
uniform vec3 uCameraPosition;

uniform float uScanPosition;
uniform float uScanRepeat;
uniform float uScanSpread;
uniform float uScanFalloff;
uniform vec4 uScanColor;
uniform float uSineSpeed;
uniform float uSineMagnitude;

void main(void)
{
	gl_FragColor = uDiffuseValue;
	
	vec3 lightWeighting_2;
  vec3 specularHighlight_3;
  vec3 specularValue_4;
  float specularIntensity_5;
  vec3 eyeDirection_6;
  vec3 normal_7;
  normal_7 = normalize(vTransformedNormal);
  eyeDirection_6 = normalize((uCameraPosition - vPosition.xyz));
  specularIntensity_5 = uSpecularIntensity;
  specularValue_4 = uSpecularValue;
  specularHighlight_3 = vec3(0.0, 0.0, 0.0);
  lightWeighting_2 = vec3(0.0, 0.0, 0.0);
  for (int i_1 = 0; i_1 < 10; i_1++) {
    if ((i_1 < uPointLightCount)) {
      vec3 tmpvar_8;
      tmpvar_8 = (uPointLightingPositions[i_1] - vPosition.xyz);
      float tmpvar_9;
      tmpvar_9 = clamp ((1.0 - (uPointLightingInvRadii[i_1] * 
        sqrt(dot (tmpvar_8, tmpvar_8))
      )), 0.0, 1.0);
      vec3 tmpvar_10;
      tmpvar_10 = normalize(tmpvar_8);
      lightWeighting_2 = (lightWeighting_2 + ((uPointLightingColors[i_1] * 
        max (dot (normal_7, tmpvar_10), 0.0)
      ) * tmpvar_9));
      vec3 I_11;
      I_11 = -(tmpvar_10);
      specularHighlight_3 = (specularHighlight_3 + ((
        (specularValue_4 * uPointLightingColors[i_1])
       * 
        pow (max (dot ((I_11 - 
          (2.0 * (dot (normal_7, I_11) * normal_7))
        ), eyeDirection_6), 0.0), specularIntensity_5)
      ) * tmpvar_9));
    };
    if ((i_1 < uDirectionalLightCount)) {
      lightWeighting_2 = (lightWeighting_2 + (uDirectionalLightingColors[i_1] * max (
        dot (normal_7, uDirectionalLightingDirections[i_1])
      , 0.0)));
    };
    if ((i_1 < uSpotLightCount)) {
      vec3 tmpvar_12;
      tmpvar_12 = (uSpotLightingPositions[i_1] - vPosition.xyz);
      float tmpvar_13;
      tmpvar_13 = clamp ((1.0 - (uSpotLightingInvRadii[i_1] * 
        sqrt(dot (tmpvar_12, tmpvar_12))
      )), 0.0, 1.0);
      vec3 tmpvar_14;
      tmpvar_14 = normalize(tmpvar_12);
      float tmpvar_15;
      tmpvar_15 = max (dot (normal_7, tmpvar_14), 0.0);
      float tmpvar_16;
      tmpvar_16 = dot (-(tmpvar_14), normalize(uSpotLightingDirections[i_1]));
      if ((tmpvar_15 > 0.0)) {
        vec3 spotContribution_17;
        spotContribution_17 = vec3(0.0, 0.0, 0.0);
        float tmpvar_18;
        tmpvar_18 = cos(uSpotLightingCutoffs[i_1]);
        float tmpvar_19;
        tmpvar_19 = cos(uSpotLightingOuterCutoffs[i_1]);
        if ((tmpvar_16 > tmpvar_18)) {
          spotContribution_17 = ((uSpotLightingColors[i_1] * tmpvar_15) * tmpvar_13);
        } else {
          if ((tmpvar_16 > tmpvar_19)) {
            spotContribution_17 = (((uSpotLightingColors[i_1] * tmpvar_15) * (
              (tmpvar_16 - tmpvar_19)
             / 
              (tmpvar_18 - tmpvar_19)
            )) * tmpvar_13);
          };
        };
        lightWeighting_2 = (lightWeighting_2 + spotContribution_17);
      };
    };
  };
  lightWeighting_2 = (lightWeighting_2 + uAmbientValue);
  vec4 tmpvar_20;
  tmpvar_20.xyz = (gl_FragColor.rgb * lightWeighting_2);
  gl_FragColor.xyz = (tmpvar_20.xyz + specularHighlight_3);
  float tmpvar_21;
  tmpvar_21 = (gl_FragCoord.z / gl_FragCoord.w);
	
	
	float sine = sin((vPosition.x + uScanPosition) * uSineSpeed) * uSineMagnitude;
	
	float scanA = mod(uScanPosition, uScanRepeat);
	float scanB = scanA - uScanRepeat;
	float scanC = scanA + uScanRepeat;
	float pos = mod(vPosition.y+sine, uScanRepeat);
	
	float difference = min(min(abs(scanA - pos), abs(scanB - pos)), abs(scanC-pos));
	
	if(difference < uScanSpread)
	{
		vec3 boost = gl_FragColor.rgb / (min(1.0, pow(difference / uScanSpread, uScanFalloff))/uScanColor.rgb);
		
		
		gl_FragColor.rgb = vec3(max(gl_FragColor.r, boost.r), max(gl_FragColor.g, boost.g), max(gl_FragColor.b, boost.b));
	}
	
	if(vPosition.y <= uFogHeightStart)
	{
  gl_FragColor = mix (uFogColor, gl_FragColor, clamp ( exp2(
    ((((
      -(uFogDensity)
     * uFogDensity) * tmpvar_21) * tmpvar_21) * 1.442695)
  ) / clamp(((vPosition.y - uFogHeightStart) / uFogHeightFalloff), 0.0, 1.0), 0.0, 1.0));
  }
}