#version 150

varying vec2 vTextureCoord;
varying vec4 vPosition;

uniform sampler2D uDiffuseSampler;
uniform sampler2D uBaseSampler;
uniform float uAlphaMultiplier;

uniform float uOffset;
uniform float uAlpha;
uniform vec2 uScreenSize;
uniform float uScale;

void main(void)
{
    vec2 tC = vTextureCoord.st;
    vec4 baseSample = texture2D(uDiffuseSampler, tC);
    tC *= uScreenSize*0.5;
    baseSample.rgb *= vec3(1.0) - (texture2D(uBaseSampler, (tC + vec2(0.0, uOffset)) / uScale) * uAlpha).rgb;

    gl_FragColor = baseSample * vec4(1,1,1,uAlphaMultiplier);
}