#version 150

attribute vec3 aVertexPosition;
attribute vec3 aVertexNormal;
attribute vec2 aTextureCoord;

uniform mat4 uModelMatrix;
uniform mat4 uViewMatrix;
uniform mat4 uProjectionMatrix;
uniform mat3 uNormalMatrix;

varying vec2 vTextureCoord;
varying vec3 vTransformedNormal;
varying vec4 vPosition;

uniform float uSqueeze;
uniform float uSqueezeDistance;

void main(void)
{
    vPosition = vec4(aVertexPosition, 1.0);
	
	// Just squeeze along the z-axis. It's a single use shader
	if(uSqueeze > 0.0)
	{
		vPosition.yz*= 1.0 - ((vPosition.x/uSqueezeDistance) * uSqueeze);
	}
	
    vPosition = uModelMatrix * vPosition;

    gl_Position = uProjectionMatrix * uViewMatrix * vPosition;
    vTextureCoord = aTextureCoord;
    vTransformedNormal = uNormalMatrix * aVertexNormal;
}