#version 150

varying vec3 vTransformedNormal;
varying vec4 vPosition;
uniform vec4 uDiffuseValue;
uniform vec3 uAmbientValue;
uniform vec3 uPointLightingPositions[10];
uniform vec3 uPointLightingColors[10];
uniform float uPointLightingInvRadii[10];
uniform int uPointLightCount;
uniform vec3 uDirectionalLightingDirections[10];
uniform vec3 uDirectionalLightingColors[10];
uniform int uDirectionalLightCount;
uniform vec3 uSpotLightingPositions[10];
uniform vec3 uSpotLightingDirections[10];
uniform vec3 uSpotLightingColors[10];
uniform float uSpotLightingInvRadii[10];
uniform float uSpotLightingCutoffs[10];
uniform float uSpotLightingOuterCutoffs[10];
uniform int uSpotLightCount;
uniform vec4 uFogColor;
uniform float uFogDensity;
void main ()
{
  vec3 lightWeighting_2;
  vec3 normal_3;
  normal_3 = normalize(vTransformedNormal);
  lightWeighting_2 = vec3(0.0, 0.0, 0.0);
  for (int i_1 = 0; i_1 < 10; i_1++) {
    if ((i_1 < uPointLightCount)) {
      vec3 tmpvar_4;
      tmpvar_4 = (uPointLightingPositions[i_1] - vPosition.xyz);
      lightWeighting_2 = (lightWeighting_2 + ((uPointLightingColors[i_1] * 
        max (dot (normal_3, normalize(tmpvar_4)), 0.0)
      ) * clamp (
        (1.0 - (uPointLightingInvRadii[i_1] * sqrt(dot (tmpvar_4, tmpvar_4))))
      , 0.0, 1.0)));
    };
    if ((i_1 < uDirectionalLightCount)) {
      lightWeighting_2 = (lightWeighting_2 + (uDirectionalLightingColors[i_1] * max (
        dot (normal_3, uDirectionalLightingDirections[i_1])
      , 0.0)));
    };
    if ((i_1 < uSpotLightCount)) {
      vec3 tmpvar_5;
      tmpvar_5 = (uSpotLightingPositions[i_1] - vPosition.xyz);
      float tmpvar_6;
      tmpvar_6 = clamp ((1.0 - (uSpotLightingInvRadii[i_1] * 
        sqrt(dot (tmpvar_5, tmpvar_5))
      )), 0.0, 1.0);
      vec3 tmpvar_7;
      tmpvar_7 = normalize(tmpvar_5);
      float tmpvar_8;
      tmpvar_8 = max (dot (normal_3, tmpvar_7), 0.0);
      float tmpvar_9;
      tmpvar_9 = dot (-(tmpvar_7), normalize(uSpotLightingDirections[i_1]));
      if ((tmpvar_8 > 0.0)) {
        vec3 spotContribution_10;
        spotContribution_10 = vec3(0.0, 0.0, 0.0);
        float tmpvar_11;
        tmpvar_11 = cos(uSpotLightingCutoffs[i_1]);
        float tmpvar_12;
        tmpvar_12 = cos(uSpotLightingOuterCutoffs[i_1]);
        if ((tmpvar_9 > tmpvar_11)) {
          spotContribution_10 = ((uSpotLightingColors[i_1] * tmpvar_8) * tmpvar_6);
        } else {
          if ((tmpvar_9 > tmpvar_12)) {
            spotContribution_10 = (((uSpotLightingColors[i_1] * tmpvar_8) * (
              (tmpvar_9 - tmpvar_12)
             / 
              (tmpvar_11 - tmpvar_12)
            )) * tmpvar_6);
          };
        };
        lightWeighting_2 = (lightWeighting_2 + spotContribution_10);
      };
    };
  };
  lightWeighting_2 = (lightWeighting_2 + uAmbientValue);
  vec4 tmpvar_13;
  tmpvar_13.xyz = (uDiffuseValue.xyz * lightWeighting_2);
  tmpvar_13.w = uDiffuseValue.w;
  float tmpvar_14;
  tmpvar_14 = (gl_FragCoord.z / gl_FragCoord.w);
  gl_FragColor = mix (uFogColor, tmpvar_13, clamp (exp2(
    ((((
      -(uFogDensity)
     * uFogDensity) * tmpvar_14) * tmpvar_14) * 1.442695)
  ), 0.0, 1.0));
}

