#version 150

varying vec2 vTextureCoord;
varying vec4 vPosition;
varying vec4 vTangent;
varying vec3 vTransformedNormal;

uniform sampler2D uDiffuseSampler;
uniform vec4 uDiffuseValue;
uniform sampler2D uDisplaceSampler;
uniform float uAlphaMultiplier;

uniform samplerCube uEnvironmentSampler;
uniform float uEnvironmentStrength;
uniform vec3 uCameraPosition;

uniform float uMagnitude;
uniform vec2 uScreenSize;

void main(void)
{
  vec3 normal_3;
  vec3 tmpvar_4;
  tmpvar_4 = normalize(vTransformedNormal);
  vec3 tmpvar_5;
  tmpvar_5 = normalize(vTangent.xyz);
  vec3 tmpvar_6;
  tmpvar_6 = ((tmpvar_4.yzx * tmpvar_5.zxy) - (tmpvar_4.zxy * tmpvar_5.yzx));
  mat3 tmpvar_7;
  tmpvar_7[0].x = tmpvar_5.x;
  tmpvar_7[0].y = tmpvar_6.x;
  tmpvar_7[0].z = tmpvar_4.x;
  tmpvar_7[1].x = tmpvar_5.y;
  tmpvar_7[1].y = tmpvar_6.y;
  tmpvar_7[1].z = tmpvar_4.y;
  tmpvar_7[2].x = tmpvar_5.z;
  tmpvar_7[2].y = tmpvar_6.z;
  tmpvar_7[2].z = tmpvar_4.z;
  normal_3 = normalize((normalize(
    ((texture2D (uDisplaceSampler, vTextureCoord).xyz * 2.0) - 1.0)
  ) * tmpvar_7));

    vec2 tC = vTextureCoord.st;
    vec2 displace = normal_3.rg;

    displace *= uMagnitude;
    displace /= uScreenSize;
	
	vec4 background = texture2D(uDiffuseSampler, (gl_FragCoord.xy / uScreenSize) + displace);
	background.rgb *= uDiffuseValue.rgb;
    gl_FragColor = mix(background, uDiffuseValue, uDiffuseValue.a);
	gl_FragColor.a = uAlphaMultiplier;
	
	if(uEnvironmentStrength!=0.0)
	{
		vec3 eyeDirection = normalize(uCameraPosition - vPosition.xyz);
		vec3 envLookup = normalize(reflect(eyeDirection, vTransformedNormal));
		float envStrength = uEnvironmentStrength;
		envLookup.z *= -1.0;
		gl_FragColor.rgb += texture(uEnvironmentSampler, envLookup).rgb * envStrength;
	}
}