#version 150

attribute vec3 aVertexPosition;
attribute vec3 aVertexNormal;
attribute vec2 aTextureCoord;
attribute vec4 aTangent;

uniform mat4 uModelMatrix;
uniform mat4 uViewMatrix;
uniform mat4 uProjectionMatrix;
uniform mat3 uNormalMatrix;

varying vec3 vTransformedNormal;
varying vec4 vPosition;
varying vec2 vTextureCoord;
varying vec4 vTangent;

uniform vec3 uWaveAmplitude;
uniform vec3 uWaveOffset;
uniform vec3 uWavelength;

void main ()
{
  vec4 tmpvar_1;
  tmpvar_1.w = 1.0;
  tmpvar_1.xyz = aVertexPosition;
  tmpvar_1.xyz += 
	vec3(
	cos((aVertexPosition.z + uWaveOffset.x) * uWavelength.x),
	cos((aVertexPosition.x + uWaveOffset.y) * uWavelength.y),
	cos((aVertexPosition.y + uWaveOffset.z) * uWavelength.z)) 
	* uWaveAmplitude;
  
  vPosition = (uModelMatrix * tmpvar_1);
  gl_Position = ((uProjectionMatrix * uViewMatrix) * vPosition);
  
  vTransformedNormal = (uNormalMatrix * aVertexNormal);
  
  vTextureCoord = aTextureCoord;
  
  vTangent = aTangent;
}

